<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/cfg-if-1.0.0/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../cfg_if/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../cfg_if/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../cfg_if/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
</pre><pre class="rust"><code><span class="doccomment">//! A macro for defining `#[cfg]` if-else statements.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The macro provided by this crate, `cfg_if`, is similar to the `if/elif` C</span>
<span class="doccomment">//! preprocessor macro by allowing definition of a cascade of `#[cfg]` cases,</span>
<span class="doccomment">//! emitting the implementation which matches first.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This allows you to conveniently provide a long list `#[cfg]`&#39;d blocks of code</span>
<span class="doccomment">//! without having to rewrite each clause multiple times.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! cfg_if::cfg_if! {</span>
<span class="doccomment">//!     if #[cfg(unix)] {</span>
<span class="doccomment">//!         fn foo() { /* unix specific functionality */ }</span>
<span class="doccomment">//!     } else if #[cfg(target_pointer_width = &quot;32&quot;)] {</span>
<span class="doccomment">//!         fn foo() { /* non-unix, 32-bit functionality */ }</span>
<span class="doccomment">//!     } else {</span>
<span class="doccomment">//!         fn foo() { /* fallback implementation */ }</span>
<span class="doccomment">//!     }</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # fn main() {}</span>
<span class="doccomment">//! ```</span>

<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/cfg-if&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">test</span>, <span class="ident">deny</span>(<span class="ident">warnings</span>))]</span>

<span class="doccomment">/// The main macro provided by this crate. See crate documentation for more</span>
<span class="doccomment">/// information.</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">cfg_if</span> {
    <span class="comment">// match if/else chains with a final `else`</span>
    ($(
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">meta</span>:<span class="ident">meta</span>)]</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens</span>:<span class="ident">tt</span>)<span class="op">*</span> }
    ) <span class="kw">else</span> <span class="op">*</span> <span class="kw">else</span> {
        $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens2</span>:<span class="ident">tt</span>)<span class="op">*</span>
    }) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro">crate::cfg_if!</span> {
            @<span class="macro-nonterminal">__items</span>
            () ;
            $( ( (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">meta</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens</span>)<span class="kw-2">*</span>) ), )<span class="op">*</span>
            ( () ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens2</span>)<span class="kw-2">*</span>) ),
        }
    };

    <span class="comment">// match if/else chains lacking a final `else`</span>
    (
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i_met</span>:<span class="ident">meta</span>)]</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i_tokens</span>:<span class="ident">tt</span>)<span class="op">*</span> }
        $(
            <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">e_met</span>:<span class="ident">meta</span>)]</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">e_tokens</span>:<span class="ident">tt</span>)<span class="op">*</span> }
        )<span class="op">*</span>
    ) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro">crate::cfg_if!</span> {
            @<span class="macro-nonterminal">__items</span>
            () ;
            ( (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i_met</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i_tokens</span>)<span class="kw-2">*</span>) ),
            $( ( (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">e_met</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">e_tokens</span>)<span class="kw-2">*</span>) ), )<span class="op">*</span>
            ( () () ),
        }
    };

    <span class="comment">// Internal and recursive macro to emit all the items</span>
    <span class="comment">//</span>
    <span class="comment">// Collects all the negated cfgs in a list at the beginning and after the</span>
    <span class="comment">// semicolon is all the remaining items</span>
    (@<span class="ident">__items</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">not</span>:<span class="ident">meta</span>,)<span class="kw-2">*</span>) ; ) =&gt; {};
    (@<span class="ident">__items</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">not</span>:<span class="ident">meta</span>,)<span class="kw-2">*</span>) ; ( ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">m</span>:<span class="ident">meta</span>),<span class="kw-2">*</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) ), $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="comment">// Emit all items within one block, applying an appropriate #[cfg]. The</span>
        <span class="comment">// #[cfg] will require all `$m` matchers specified and must also negate</span>
        <span class="comment">// all previous matchers.</span>
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">m</span>,)<span class="op">*</span> <span class="ident">not</span>(<span class="ident">any</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">not</span>),<span class="kw-2">*</span>))))]</span> <span class="macro-nonterminal">$</span><span class="macro">crate::cfg_if!</span> { @<span class="macro-nonterminal">__identity</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens</span>)<span class="op">*</span> }

        <span class="comment">// Recurse to emit all other items in `$rest`, and when we do so add all</span>
        <span class="comment">// our `$m` matchers to the list of `$not` matchers as future emissions</span>
        <span class="comment">// will have to negate everything we just matched as well.</span>
        <span class="macro-nonterminal">$</span><span class="macro">crate::cfg_if!</span> { @<span class="macro-nonterminal">__items</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">not</span>,)<span class="op">*</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">m</span>,)<span class="kw-2">*</span>) ; $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="op">*</span> }
    };

    <span class="comment">// Internal macro to make __apply work out right for different match types,</span>
    <span class="comment">// because of how macros matching/expand stuff.</span>
    (@<span class="ident">__identity</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tokens</span>)<span class="op">*</span>
    };
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="macro">cfg_if!</span> {
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span> {
            <span class="kw">use</span> <span class="ident">core::option::Option</span> <span class="kw">as</span> <span class="ident">Option2</span>;
            <span class="kw">fn</span> <span class="ident">works1</span>() -&gt; <span class="ident">Option2</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> { <span class="prelude-val">Some</span>(<span class="number">1</span>) }
        } <span class="kw">else</span> {
            <span class="kw">fn</span> <span class="ident">works1</span>() -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> { <span class="prelude-val">None</span> }
        }
    }

    <span class="macro">cfg_if!</span> {
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">foo</span>)]</span> {
            <span class="kw">fn</span> <span class="ident">works2</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">false</span> }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span> {
            <span class="kw">fn</span> <span class="ident">works2</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">true</span> }
        } <span class="kw">else</span> {
            <span class="kw">fn</span> <span class="ident">works2</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">false</span> }
        }
    }

    <span class="macro">cfg_if!</span> {
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">foo</span>)]</span> {
            <span class="kw">fn</span> <span class="ident">works3</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">false</span> }
        } <span class="kw">else</span> {
            <span class="kw">fn</span> <span class="ident">works3</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">true</span> }
        }
    }

    <span class="macro">cfg_if!</span> {
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span> {
            <span class="kw">use</span> <span class="ident">core::option::Option</span> <span class="kw">as</span> <span class="ident">Option3</span>;
            <span class="kw">fn</span> <span class="ident">works4</span>() -&gt; <span class="ident">Option3</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> { <span class="prelude-val">Some</span>(<span class="number">1</span>) }
        }
    }

    <span class="macro">cfg_if!</span> {
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">foo</span>)]</span> {
            <span class="kw">fn</span> <span class="ident">works5</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">false</span> }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span> {
            <span class="kw">fn</span> <span class="ident">works5</span>() -&gt; <span class="ident">bool</span> { <span class="bool-val">true</span> }
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">it_works</span>() {
        <span class="macro">assert!</span>(<span class="ident">works1</span>().<span class="ident">is_some</span>());
        <span class="macro">assert!</span>(<span class="ident">works2</span>());
        <span class="macro">assert!</span>(<span class="ident">works3</span>());
        <span class="macro">assert!</span>(<span class="ident">works4</span>().<span class="ident">is_some</span>());
        <span class="macro">assert!</span>(<span class="ident">works5</span>());
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::assertions_on_constants</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_usage_within_a_function</span>() {
        <span class="macro">cfg_if!</span> {<span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">debug_assertions</span>)]</span> {
            <span class="comment">// we want to put more than one thing here to make sure that they</span>
            <span class="comment">// all get configured properly.</span>
            <span class="macro">assert!</span>(<span class="macro">cfg!</span>(<span class="ident">debug_assertions</span>));
            <span class="macro">assert_eq!</span>(<span class="number">4</span>, <span class="number">2</span><span class="op">+</span><span class="number">2</span>);
        } <span class="kw">else</span> {
            <span class="macro">assert!</span>(<span class="ident">works1</span>().<span class="ident">is_some</span>());
            <span class="macro">assert_eq!</span>(<span class="number">10</span>, <span class="number">5</span><span class="op">+</span><span class="number">5</span>);
        }}
    }

    <span class="kw">trait</span> <span class="ident">Trait</span> {
        <span class="kw">fn</span> <span class="ident">blah</span>(<span class="kw-2">&amp;</span><span class="self">self</span>);
    }

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
    <span class="kw">struct</span> <span class="ident">Struct</span>;

    <span class="kw">impl</span> <span class="ident">Trait</span> <span class="kw">for</span> <span class="ident">Struct</span> {
        <span class="macro">cfg_if!</span> {
            <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;blah&quot;</span>)]</span> {
                <span class="kw">fn</span> <span class="ident">blah</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {
                    <span class="macro">unimplemented!</span>();
                }
            } <span class="kw">else</span> {
                <span class="kw">fn</span> <span class="ident">blah</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {
                    <span class="macro">unimplemented!</span>();
                }
            }
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="cfg_if" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>